package de.jottyfan.quickiemod.container;

import de.jottyfan.quickiemod.Quickiemod;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.client.gui.DrawContext;
import net.minecraft.client.gui.screen.ingame.HandledScreen;
import net.minecraft.client.gui.screen.ingame.ScreenHandlerProvider;
import net.minecraft.entity.player.PlayerInventory;
import net.minecraft.text.Text;
import net.minecraft.util.Identifier;

/**
 *
 * @author jotty
 *
 */
@Environment(EnvType.CLIENT)
public class BlockStackerScreen extends HandledScreen<BlockStackerScreenHandler>
		implements ScreenHandlerProvider<BlockStackerScreenHandler> {
	private final static Identifier TEXTURE = Identifier.of(Quickiemod.MOD_ID, "textures/gui/blockstacker.png");
	private final Integer containerHeight = 222;
	private final Integer containerWidth = 176;

	public BlockStackerScreen(BlockStackerScreenHandler handler, PlayerInventory inventory, Text title) {
		super(handler, inventory, title);
	}

	@Override
	public void render(DrawContext drawContext, int mouseX, int mouseY, float partialTicks) {
		this.renderInGameBackground(drawContext);
		super.render(drawContext, mouseX, mouseY, partialTicks);
		this.drawMouseoverTooltip(drawContext, mouseX, mouseY);
	}

	@Override
	protected void drawBackground(DrawContext context, float delta, int mouseX, int mouseY) {
//    context.setShaderColor(1.0F, 1.0F, 1.0F, 1.0F);
		int guiX = (this.width - this.containerWidth) / 2;
		int guiY = (this.height - this.containerHeight) / 2;
    super.renderInGameBackground(context);
//		context.drawTexture(TEXTURE, guiX, guiY, 0f, 0f, containerWidth, containerHeight, 0, 0);
	}
}
