package de.jottyfan.quickiemod.item;

import java.util.Random;

import net.minecraft.component.DataComponentTypes;
import net.minecraft.entity.ItemEntity;
import net.minecraft.entity.LivingEntity;
import net.minecraft.entity.passive.ChickenEntity;
import net.minecraft.entity.passive.CowEntity;
import net.minecraft.entity.passive.HorseEntity;
import net.minecraft.entity.passive.SheepEntity;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Items;
import net.minecraft.item.ShearsItem;
import net.minecraft.registry.RegistryKey;
import net.minecraft.registry.RegistryKeys;
import net.minecraft.util.ActionResult;
import net.minecraft.util.DyeColor;
import net.minecraft.util.Hand;
import net.minecraft.util.Identifier;
import net.minecraft.util.math.Vec3d;

/**
 *
 * @author jotty
 *
 */
public class ToolSpeedpowderShears extends ShearsItem {

	public ToolSpeedpowderShears(Identifier identifier) {
		super(new Item.Settings().component(DataComponentTypes.TOOL, ShearsItem.createToolComponent()).useItemPrefixedTranslationKey().registryKey(RegistryKey.of(RegistryKeys.ITEM, identifier)));
	}

	@Override
	public ActionResult useOnEntity(ItemStack stack, PlayerEntity user, LivingEntity entity, Hand hand) {
		Vec3d pos = entity.getPos();
		Integer amount = 3 + new Random().nextInt(4);
		if (entity instanceof SheepEntity) {
			SheepEntity sheep = (SheepEntity) entity;
			if (sheep.isShearable()) {
				sheep.setSheared(true);
				sheep.playAmbientSound();
				DyeColor color = sheep.getColor();
				Item item = Items.WHITE_WOOL;
				if (color.equals(DyeColor.BLACK)) {
					item = Items.BLACK_WOOL;
				} else if (color.equals(DyeColor.GRAY)) {
					item = Items.GRAY_WOOL;
				} else if (color.equals(DyeColor.LIGHT_GRAY)) {
					item = Items.LIGHT_GRAY_WOOL;
				} else if (color.equals(DyeColor.BROWN)) {
					item = Items.BROWN_WOOL;
				} else if (color.equals(DyeColor.BLUE)) {
					item = Items.BLUE_WOOL;
				} else if (color.equals(DyeColor.LIGHT_BLUE)) {
					item = Items.LIGHT_BLUE_WOOL;
				} else if (color.equals(DyeColor.GREEN)) {
					item = Items.GREEN_WOOL;
				} else if (color.equals(DyeColor.LIME)) {
					item = Items.LIME_WOOL;
				} else if (color.equals(DyeColor.CYAN)) {
					item = Items.CYAN_WOOL;
				} else if (color.equals(DyeColor.MAGENTA)) {
					item = Items.MAGENTA_WOOL;
				} else if (color.equals(DyeColor.ORANGE)) {
					item = Items.ORANGE_WOOL;
				} else if (color.equals(DyeColor.PINK)) {
					item = Items.PINK_WOOL;
				} else if (color.equals(DyeColor.PURPLE)) {
					item = Items.PURPLE_WOOL;
				} else if (color.equals(DyeColor.RED)) {
					item = Items.RED_WOOL;
				} else if (color.equals(DyeColor.YELLOW)) {
					item = Items.YELLOW_WOOL;
				}
				user.getWorld().spawnEntity(new ItemEntity(user.getWorld(), pos.getX(), pos.getY(), pos.getZ(), new ItemStack(item, amount)));
				return ActionResult.SUCCESS;
			}
		} else if (entity instanceof HorseEntity) {
			HorseEntity horse = (HorseEntity) entity;
			horse.playAmbientSound();
			user.getWorld().spawnEntity(new ItemEntity(user.getWorld(), pos.getX(), pos.getY(), pos.getZ(), new ItemStack(Items.LEATHER, amount)));
			return ActionResult.SUCCESS;
		} else if (entity instanceof CowEntity) {
			CowEntity cow = (CowEntity) entity;
			cow.playAmbientSound();
			user.getWorld().spawnEntity(new ItemEntity(user.getWorld(), pos.getX(), pos.getY(), pos.getZ(), new ItemStack(Items.LEATHER, amount)));
			return ActionResult.SUCCESS;
		} else if (entity instanceof ChickenEntity) {
			ChickenEntity cow = (ChickenEntity) entity;
			cow.playAmbientSound();
			user.getWorld().spawnEntity(new ItemEntity(user.getWorld(), pos.getX(), pos.getY(), pos.getZ(), new ItemStack(Items.FEATHER, amount)));
			return ActionResult.SUCCESS;
		}
		return ActionResult.PASS;
	}
}
